package encoding

import (
	"bytes"
	"encoding/gob"
)

func ToBytes(v interface{}) ([]byte, error) {
	var buffer bytes.Buffer
	enc := gob.NewEncoder(&buffer)
	if err := enc.Encode(v); err != nil {
		return nil, err
	}

	return buffer.Bytes(), nil
}

func FromBytes(v []byte, dst interface{}) error {
	buffer := bytes.NewBuffer(v)
	dec := gob.NewDecoder(buffer)

	return dec.Decode(dst)
}
